#!/bin/sh

# ---------------------------------------------------------------------------
# ENVIROMENT VARIABLES
# ---------------------------------------------------------------------------
INSTALL_PATH=/usr/local/lib

STD_LIB_PATH=/usr/lib
STD_BIN_PATH=/usr/bin

EPREFIX=$INSTALL_PATH/sK1
PREFIX=$EPREFIX

# ---------------------------------------------------------------------------
# CLEAR POSSIBLE PREVIOUS sK1 INSTALLATION
# ---------------------------------------------------------------------------
rm -rf $EPREFIX
rm -f $STD_LIB_PATH/libsk1_tk8.5.so
rm -f $STD_LIB_PATH/libsk1_tcl8.5.so
rm -f $STD_BIN_PATH/sk1_python
rm -f $STD_BIN_PATH/sk1_tclsh
rm -f $STD_BIN_PATH/sk1_wish
rm -f $STD_BIN_PATH/sk1


echo
echo ---------------------------------------------------------------------------
echo Tcl/Tk BUILD
echo ---------------------------------------------------------------------------
echo

mkdir $EPREFIX

rm -f tk8.5a3/unix/tkUnixDefault.h;cp patches/tk8.5a3/unix/tkUnixDefault.h tk8.5a3/unix/tkUnixDefault.h
rm -f tk8.5a3/unix/tkUnixWm.c;cp patches/tk8.5a3/unix/tkUnixWm.c tk8.5a3/unix/tkUnixWm.c

cd tcl8.5a3/unix

./configure --prefix=$PREFIX --exec-prefix=$EPREFIX

make
make install

cd ../../tk8.5a3/unix

./configure --prefix=$PREFIX --exec-prefix=$EPREFIX --enable-xft

make
make install

mkdir $EPREFIX/include

cp -r ../../include/tcl8.5a3 $EPREFIX/include/tcl8.5a3
cp -r ../../include/tk8.5a3 $EPREFIX/include/tk8.5a3

ln -s $PREFIX/lib/libtcl8.5.so $STD_LIB_PATH/libsk1_tcl8.5.so
ln -s $PREFIX/lib/libtk8.5.so $STD_LIB_PATH/libsk1_tk8.5.so
ln -s $PREFIX/bin/wish8.5 $STD_BIN_PATH/sk1_wish
ln -s $PREFIX/bin/tclsh8.5 $STD_BIN_PATH/sk1_tclsh

echo
echo ---------------------------------------------------------------------------
echo Python BUILD
echo ---------------------------------------------------------------------------
echo

cd ../../Python-2.4.2
cat ../patches/Python-2.4.2/lib-tk/Tkinter.py >Lib/lib-tk/Tkinter.py

rm -f setup.py;cp ../patches/Python-2.4.2/setup.py setup.py

export LD_LIBARY_PATH=$PREFIX/lib
export LD_RUN_PATH=$PREFIX/lib 

./configure --prefix=$PREFIX --exec-prefix=$EPREFIX

make
make install

ln -s $PREFIX/bin/python $STD_BIN_PATH/sk1_python

echo
echo ---------------------------------------------------------------------------
echo Python Image Library BUILD
echo ---------------------------------------------------------------------------
echo

cd ../Imaging-1.1.5
$EPREFIX/bin/python setup.py build_ext -i
$EPREFIX/bin/python setup.py install 

cp -r ../include/PIL $EPREFIX/include

echo
echo ---------------------------------------------------------------------------
echo Python XML package BUILD
echo ---------------------------------------------------------------------------
echo

cd ../PyXML-0.8.3
$EPREFIX/bin/python setup.py build
$EPREFIX/bin/python setup.py install 
ln -s $EPREFIX/lib/python2.4/site-packages/_xmlplus $EPREFIX/xml


echo
echo ---------------------------------------------------------------------------
echo TkPNG package BUILD
echo ---------------------------------------------------------------------------
echo

cd ../tkpng0.7
rm -f generic/tkImgPNG.c;cp ../patches/tkpng0.7/generic/tkImgPNG.c generic/tkImgPNG.c
./configure --prefix=$PREFIX --exec-prefix=$EPREFIX --with-tcl=$PREFIX/lib --with-tk=$PREFIX/lib --with-tclinclude=$PREFIX/include --with-tkinclude=$PREFIX/include

make
make install

echo
echo ---------------------------------------------------------------------------
echo Tile package BUILD
echo ---------------------------------------------------------------------------
echo

cd ../tile-0.7.2
./configure --prefix=$PREFIX --exec-prefix=$EPREFIX --with-tcl=$PREFIX/lib --with-tk=$PREFIX/lib

make
make install


# Sketch Libs build:
myEPREFIX=`echo $EPREFIX|sed 's/\//\\\ \//g'|sed 's/ \//\//g'`


echo
echo ---------------------------------------------------------------------------
echo Filter module Build
echo ---------------------------------------------------------------------------
echo

cd ../sketch_mod/Filter

sed 's/_MY_INSTALL_DIR_/'"$myEPREFIX"'/g' ../../patches/Filter/Makefile.pre.in |sed 's/_MY_INSTALL_PREFIX_/'"$myEPREFIX"'/g'> Makefile.pre.in

make -f Makefile.pre.in Makefile VERSION=2.4 installdir=$EPREFIX
make
#------------install-------------
cp streamfilter.so $EPREFIX/lib/streamfilter.so


echo
echo ---------------------------------------------------------------------------
echo pax-0.6.0 Build
echo ---------------------------------------------------------------------------
echo

cd ../pax-0.6.0

sed 's/_MY_INSTALL_DIR_/'"$myEPREFIX"'/g' ../../patches/pax-0.6.0/Makefile.pre.in |sed 's/_MY_INSTALL_PREFIX_/'"$myEPREFIX"'/g'> Makefile.pre.in

myTCL_HEADERS=`echo $EPREFIX/include|sed 's/\//\\\ \//g'|sed 's/ \//\//g'`
myTCL_LIBS=`echo $EPREFIX/lib|sed 's/\//\\\ \//g'|sed 's/ \//\//g'`

sed 's/_MY_TCL_HEADERS_/'"$myTCL_HEADERS"'/g' ../../patches/pax-0.6.0/Setup.in |sed 's/_MY_TCL_LIBS_/'"$myTCL_LIBS"'/g'> Setup.in

make -f Makefile.pre.in Makefile VERSION=2.4 installdir=$EPREFIX
make
#------------install-------------
cp paxtkinter.so $EPREFIX/lib/paxtkinter.so
cp paxmodule.so $EPREFIX/lib/paxmodule.so
mkdir $EPREFIX/lib/X11
cp X.py $EPREFIX/lib/X11/X.py
cp -r Generate $EPREFIX/lib/X11/Generate

echo
echo ---------------------------------------------------------------------------
echo PS Modules
echo ---------------------------------------------------------------------------
echo

cd ../Modules

myIMAGING_HEADER=`echo $EPREFIX/include/PIL/libImaging|sed 's/\//\\\ \//g'|sed 's/ \//\//g'`

sed 's/_MY_IMAGING_HEADER_/'"$myIMAGING_HEADER"'/g' ../../patches/Modules/Setup.in > Setup.in
cat ../../patches/Modules/Setup.config > Setup.config

sed 's/_MY_INSTALL_DIR_/'"$myEPREFIX"'/g' ../../patches/Modules/Makefile.pre.in |sed 's/_MY_INSTALL_PREFIX_/'"$myEPREFIX"'/g'> Makefile.pre.in

make -f Makefile.pre.in Makefile VERSION=2.4 installdir=$EPREFIX
make
#------------install-------------
cp _sketchmodule.so $EPREFIX/lib/_sketchmodule.so
cp skreadmodule.so $EPREFIX/lib/skreadmodule.so
cp _type1module.so $EPREFIX/lib/_type1module.so
cp pstokenize.so $EPREFIX/lib/pstokenize.so

echo
echo ---------------------------------------------------------------------------
echo "Code patching"
echo ---------------------------------------------------------------------------
echo

cat ../../patches/tk8.5a3/lib.tk8.5/tk.tcl>$PREFIX/lib/tk8.5/tk.tcl
cat ../../patches/tk8.5a3/lib.tk8.5/menu.tcl>$PREFIX/lib/tk8.5/menu.tcl

cd ../../patches/tile0.7.2
rm -f $PREFIX/lib/tile0.7.2/*.tcl
cp -r `ls` $PREFIX/lib/tile0.7.2
rm -rf $EPREFIX/man
rm -rf $EPREFIX/include

echo
echo ---------------------------------------------------------------------------
echo sK1 BUILD
echo ---------------------------------------------------------------------------
echo

cd ../../sK1
cp -r `ls` $EPREFIX
cd $EPREFIX
sk1_python compile.py
rm compile.py
chmod +x main.py
ln -s $PREFIX/main.py $STD_BIN_PATH/sk1
cd Sketch;rm -rf `find ./ -depth|grep "^.*\.py$" `;cd ..
ln -s $PREFIX/share/ttk-themes/Plastik $PREFIX/lib/tk8.5/Plastik.theme

echo
echo ---------------------------------------------------------------------------
echo sK1 installation completed!
echo ---------------------------------------------------------------------------
echo
echo "To launch sK1, please log out root session and under regular"
echo "user just run \'sk1\' console command." 
